#ifndef __ogl_h_
#define __ogl_h_

#ifdef __cplusplus
extern "C" { 
#endif

#include <stdio.h>

#if defined(WIN32)
#define _GDI32_
#include <windows.h>
#else
#define WINGDIAPI
#define APIENTRY
#endif

#include <GL/gl.h>
#include "state.h"

extern char *stateClear(char *tmp, GLbitfield mask);
extern char *stateBegin (GLenum mode);
extern char *stateColorMaterial (char *tmp, GLenum face, GLenum mode);
extern char *stateCullFace (GLenum mode);
extern char *stateAble (GLenum cap, int *eb);
extern char *stateFrontFace (GLenum mode);
extern char *stateHint (char *tmp, GLenum target, GLenum mode);
extern char *stateShadeModel (GLenum mode);
extern char *stateShadeModel (GLenum mode);
extern void printStat();

#include "total.h"

static char *glNames[TOTAL_GL] = {
"glAccum",
"glAlphaFunc",
"glAreTexturesResident",
"glArrayElement",
"glBegin",
"glBindTexture",
"glBitmap",
"glBlendFunc",
"glCallList",
"glCallLists",
"glClear",
"glClearAccum",
"glClearColor",
"glClearDepth",
"glClearIndex",
"glClearStencil",
"glClipPlane",
"glColor3b",
"glColor3bv",
"glColor3d",
"glColor3dv",
"glColor3f",
"glColor3fv",
"glColor3i",
"glColor3iv",
"glColor3s",
"glColor3sv",
"glColor3ub",
"glColor3ubv",
"glColor3ui",
"glColor3uiv",
"glColor3us",
"glColor3usv",
"glColor4b",
"glColor4bv",
"glColor4d",
"glColor4dv",
"glColor4f",
"glColor4fv",
"glColor4i",
"glColor4iv",
"glColor4s",
"glColor4sv",
"glColor4ub",
"glColor4ubv",
"glColor4ui",
"glColor4uiv",
"glColor4us",
"glColor4usv",
"glColorMask",
"glColorMaterial",
"glColorPointer",
"glCopyPixels",
"glCopyTexImage1D",
"glCopyTexImage2D",
"glCopyTexSubImage1D",
"glCopyTexSubImage2D",
"glCullFace",
"glDeleteLists",
"glDeleteTextures",
"glDepthFunc",
"glDepthMask",
"glDepthRange",
"glDisable",
"glDisableClientState",
"glDrawArrays",
"glDrawBuffer",
"glDrawElements",
"glDrawPixels",
"glEdgeFlag",
"glEdgeFlagPointer",
"glEdgeFlagv",
"glEnable",
"glEnableClientState",
"glEnd",
"glEndList",
"glEvalCoord1d",
"glEvalCoord1dv",
"glEvalCoord1f",
"glEvalCoord1fv",
"glEvalCoord2d",
"glEvalCoord2dv",
"glEvalCoord2f",
"glEvalCoord2fv",
"glEvalMesh1",
"glEvalMesh2",
"glEvalPoint1",
"glEvalPoint2",
"glFeedbackBuffer",
"glFinish",
"glFlush",
"glFogf",
"glFogfv",
"glFogi",
"glFogiv",
"glFrontFace",
"glFrustum",
"glGenLists",
"glGenTextures",
"glGetBooleanv",
"glGetClipPlane",
"glGetDoublev",
"glGetError",
"glGetFloatv",
"glGetIntegerv",
"glGetLightfv",
"glGetLightiv",
"glGetMapdv",
"glGetMapfv",
"glGetMapiv",
"glGetMaterialfv",
"glGetMaterialiv",
"glGetPixelMapfv",
"glGetPixelMapuiv",
"glGetPixelMapusv",
"glGetPointerv",
"glGetPolygonStipple",
"glGetTexEnvfv",
"glGetTexEnviv",
"glGetTexGendv",
"glGetTexGenfv",
"glGetTexGeniv",
"glGetTexImage",
"glGetTexLevelParameterfv",
"glGetTexLevelParameteriv",
"glGetTexParameterfv",
"glGetTexParameteriv",
"glHint",
"glIndexMask",
"glIndexPointer",
"glIndexd",
"glIndexdv",
"glIndexf",
"glIndexfv",
"glIndexi",
"glIndexiv",
"glIndexs",
"glIndexsv",
"glIndexub",
"glIndexubv",
"glInitNames",
"glInterleavedArrays",
"glIsEnabled",
"glIsList",
"glIsTexture",
"glLightModelf",
"glLightModelfv",
"glLightModeli",
"glLightModeliv",
"glLightf",
"glLightfv",
"glLighti",
"glLightiv",
"glLineStipple",
"glLineWidth",
"glListBase",
"glLoadIdentity",
"glLoadMatrixd",
"glLoadMatrixf",
"glLoadName",
"glLogicOp",
"glMap1d",
"glMap1f",
"glMap2d",
"glMap2f",
"glMapGrid1d",
"glMapGrid1f",
"glMapGrid2d",
"glMapGrid2f",
"glMaterialf",
"glMaterialfv",
"glMateriali",
"glMaterialiv",
"glMatrixMode",
"glMultMatrixd",
"glMultMatrixf",
"glNewList",
"glNormal3b",
"glNormal3bv",
"glNormal3d",
"glNormal3dv",
"glNormal3f",
"glNormal3fv",
"glNormal3i",
"glNormal3iv",
"glNormal3s",
"glNormal3sv",
"glNormalPointer",
"glOrtho",
"glPassThrough",
"glPixelMapfv",
"glPixelMapuiv",
"glPixelMapusv",
"glPixelStoref",
"glPixelStorei",
"glPixelTransferf",
"glPixelTransferi",
"glPixelZoom",
"glPointSize",
"glPolygonMode",
"glPolygonOffset",
"glPolygonStipple",
"glPopAttrib",
"glPopClientAttrib",
"glPopMatrix",
"glPopName",
"glPrioritizeTextures",
"glPushAttrib",
"glPushClientAttrib",
"glPushMatrix",
"glPushName",
"glRasterPos2d",
"glRasterPos2dv",
"glRasterPos2f",
"glRasterPos2fv",
"glRasterPos2i",
"glRasterPos2iv",
"glRasterPos2s",
"glRasterPos2sv",
"glRasterPos3d",
"glRasterPos3dv",
"glRasterPos3f",
"glRasterPos3fv",
"glRasterPos3i",
"glRasterPos3iv",
"glRasterPos3s",
"glRasterPos3sv",
"glRasterPos4d",
"glRasterPos4dv",
"glRasterPos4f",
"glRasterPos4fv",
"glRasterPos4i",
"glRasterPos4iv",
"glRasterPos4s",
"glRasterPos4sv",
"glReadBuffer",
"glReadPixels",
"glRectd",
"glRectdv",
"glRectf",
"glRectfv",
"glRecti",
"glRectiv",
"glRects",
"glRectsv",
"glRenderMode",
"glRotated",
"glRotatef",
"glScaled",
"glScalef",
"glScissor",
"glSelectBuffer",
"glShadeModel",
"glStencilFunc",
"glStencilMask",
"glStencilOp",
"glTexCoord1d",
"glTexCoord1dv",
"glTexCoord1f",
"glTexCoord1fv",
"glTexCoord1i",
"glTexCoord1iv",
"glTexCoord1s",
"glTexCoord1sv",
"glTexCoord2d",
"glTexCoord2dv",
"glTexCoord2f",
"glTexCoord2fv",
"glTexCoord2i",
"glTexCoord2iv",
"glTexCoord2s",
"glTexCoord2sv",
"glTexCoord3d",
"glTexCoord3dv",
"glTexCoord3f",
"glTexCoord3fv",
"glTexCoord3i",
"glTexCoord3iv",
"glTexCoord3s",
"glTexCoord3sv",
"glTexCoord4d",
"glTexCoord4dv",
"glTexCoord4f",
"glTexCoord4fv",
"glTexCoord4i",
"glTexCoord4iv",
"glTexCoord4s",
"glTexCoord4sv",
"glTexCoordPointer",
"glTexEnvf",
"glTexEnvfv",
"glTexEnvi",
"glTexEnviv",
"glTexGend",
"glTexGendv",
"glTexGenf",
"glTexGenfv",
"glTexGeni",
"glTexGeniv",
"glTexImage1D",
"glTexImage2D",
"glTexImage3D",
"glTexParameterf",
"glTexParameterfv",
"glTexParameteri",
"glTexParameteriv",
"glTexSubImage1D",
"glTexSubImage2D",
"glTranslated",
"glTranslatef",
"glVertex2d",
"glVertex2dv",
"glVertex2f",
"glVertex2fv",
"glVertex2i",
"glVertex2iv",
"glVertex2s",
"glVertex2sv",
"glVertex3d",
"glVertex3dv",
"glVertex3f",
"glVertex3fv",
"glVertex3i",
"glVertex3iv",
"glVertex3s",
"glVertex3sv",
"glVertex4d",
"glVertex4dv",
"glVertex4f",
"glVertex4fv",
"glVertex4i",
"glVertex4iv",
"glVertex4s",
"glVertex4sv",
"glVertexPointer",
"glViewport",
"glGetString"};

enum {
API_glAccum,
API_glAlphaFunc,
API_glAreTexturesResident,
API_glArrayElement,
API_glBegin,
API_glBindTexture,
API_glBitmap,
API_glBlendFunc,
API_glCallList,
API_glCallLists,
API_glClear,
API_glClearAccum,
API_glClearColor,
API_glClearDepth,
API_glClearIndex,
API_glClearStencil,
API_glClipPlane,
API_glColor3b,
API_glColor3bv,
API_glColor3d,
API_glColor3dv,
API_glColor3f,
API_glColor3fv,
API_glColor3i,
API_glColor3iv,
API_glColor3s,
API_glColor3sv,
API_glColor3ub,
API_glColor3ubv,
API_glColor3ui,
API_glColor3uiv,
API_glColor3us,
API_glColor3usv,
API_glColor4b,
API_glColor4bv,
API_glColor4d,
API_glColor4dv,
API_glColor4f,
API_glColor4fv,
API_glColor4i,
API_glColor4iv,
API_glColor4s,
API_glColor4sv,
API_glColor4ub,
API_glColor4ubv,
API_glColor4ui,
API_glColor4uiv,
API_glColor4us,
API_glColor4usv,
API_glColorMask,
API_glColorMaterial,
API_glColorPointer,
API_glCopyPixels,
API_glCopyTexImage1D,
API_glCopyTexImage2D,
API_glCopyTexSubImage1D,
API_glCopyTexSubImage2D,
API_glCullFace,
API_glDeleteLists,
API_glDeleteTextures,
API_glDepthFunc,
API_glDepthMask,
API_glDepthRange,
API_glDisable,
API_glDisableClientState,
API_glDrawArrays,
API_glDrawBuffer,
API_glDrawElements,
API_glDrawPixels,
API_glEdgeFlag,
API_glEdgeFlagPointer,
API_glEdgeFlagv,
API_glEnable,
API_glEnableClientState,
API_glEnd,
API_glEndList,
API_glEvalCoord1d,
API_glEvalCoord1dv,
API_glEvalCoord1f,
API_glEvalCoord1fv,
API_glEvalCoord2d,
API_glEvalCoord2dv,
API_glEvalCoord2f,
API_glEvalCoord2fv,
API_glEvalMesh1,
API_glEvalMesh2,
API_glEvalPoint1,
API_glEvalPoint2,
API_glFeedbackBuffer,
API_glFinish,
API_glFlush,
API_glFogf,
API_glFogfv,
API_glFogi,
API_glFogiv,
API_glFrontFace,
API_glFrustum,
API_glGenLists,
API_glGenTextures,
API_glGetBooleanv,
API_glGetClipPlane,
API_glGetDoublev,
API_glGetError,
API_glGetFloatv,
API_glGetIntegerv,
API_glGetLightfv,
API_glGetLightiv,
API_glGetMapdv,
API_glGetMapfv,
API_glGetMapiv,
API_glGetMaterialfv,
API_glGetMaterialiv,
API_glGetPixelMapfv,
API_glGetPixelMapuiv,
API_glGetPixelMapusv,
API_glGetPointerv,
API_glGetPolygonStipple,
API_glGetTexEnvfv,
API_glGetTexEnviv,
API_glGetTexGendv,
API_glGetTexGenfv,
API_glGetTexGeniv,
API_glGetTexImage,
API_glGetTexLevelParameterfv,
API_glGetTexLevelParameteriv,
API_glGetTexParameterfv,
API_glGetTexParameteriv,
API_glHint,
API_glIndexMask,
API_glIndexPointer,
API_glIndexd,
API_glIndexdv,
API_glIndexf,
API_glIndexfv,
API_glIndexi,
API_glIndexiv,
API_glIndexs,
API_glIndexsv,
API_glIndexub,
API_glIndexubv,
API_glInitNames,
API_glInterleavedArrays,
API_glIsEnabled,
API_glIsList,
API_glIsTexture,
API_glLightModelf,
API_glLightModelfv,
API_glLightModeli,
API_glLightModeliv,
API_glLightf,
API_glLightfv,
API_glLighti,
API_glLightiv,
API_glLineStipple,
API_glLineWidth,
API_glListBase,
API_glLoadIdentity,
API_glLoadMatrixd,
API_glLoadMatrixf,
API_glLoadName,
API_glLogicOp,
API_glMap1d,
API_glMap1f,
API_glMap2d,
API_glMap2f,
API_glMapGrid1d,
API_glMapGrid1f,
API_glMapGrid2d,
API_glMapGrid2f,
API_glMaterialf,
API_glMaterialfv,
API_glMateriali,
API_glMaterialiv,
API_glMatrixMode,
API_glMultMatrixd,
API_glMultMatrixf,
API_glNewList,
API_glNormal3b,
API_glNormal3bv,
API_glNormal3d,
API_glNormal3dv,
API_glNormal3f,
API_glNormal3fv,
API_glNormal3i,
API_glNormal3iv,
API_glNormal3s,
API_glNormal3sv,
API_glNormalPointer,
API_glOrtho,
API_glPassThrough,
API_glPixelMapfv,
API_glPixelMapuiv,
API_glPixelMapusv,
API_glPixelStoref,
API_glPixelStorei,
API_glPixelTransferf,
API_glPixelTransferi,
API_glPixelZoom,
API_glPointSize,
API_glPolygonMode,
API_glPolygonOffset,
API_glPolygonStipple,
API_glPopAttrib,
API_glPopClientAttrib,
API_glPopMatrix,
API_glPopName,
API_glPrioritizeTextures,
API_glPushAttrib,
API_glPushClientAttrib,
API_glPushMatrix,
API_glPushName,
API_glRasterPos2d,
API_glRasterPos2dv,
API_glRasterPos2f,
API_glRasterPos2fv,
API_glRasterPos2i,
API_glRasterPos2iv,
API_glRasterPos2s,
API_glRasterPos2sv,
API_glRasterPos3d,
API_glRasterPos3dv,
API_glRasterPos3f,
API_glRasterPos3fv,
API_glRasterPos3i,
API_glRasterPos3iv,
API_glRasterPos3s,
API_glRasterPos3sv,
API_glRasterPos4d,
API_glRasterPos4dv,
API_glRasterPos4f,
API_glRasterPos4fv,
API_glRasterPos4i,
API_glRasterPos4iv,
API_glRasterPos4s,
API_glRasterPos4sv,
API_glReadBuffer,
API_glReadPixels,
API_glRectd,
API_glRectdv,
API_glRectf,
API_glRectfv,
API_glRecti,
API_glRectiv,
API_glRects,
API_glRectsv,
API_glRenderMode,
API_glRotated,
API_glRotatef,
API_glScaled,
API_glScalef,
API_glScissor,
API_glSelectBuffer,
API_glShadeModel,
API_glStencilFunc,
API_glStencilMask,
API_glStencilOp,
API_glTexCoord1d,
API_glTexCoord1dv,
API_glTexCoord1f,
API_glTexCoord1fv,
API_glTexCoord1i,
API_glTexCoord1iv,
API_glTexCoord1s,
API_glTexCoord1sv,
API_glTexCoord2d,
API_glTexCoord2dv,
API_glTexCoord2f,
API_glTexCoord2fv,
API_glTexCoord2i,
API_glTexCoord2iv,
API_glTexCoord2s,
API_glTexCoord2sv,
API_glTexCoord3d,
API_glTexCoord3dv,
API_glTexCoord3f,
API_glTexCoord3fv,
API_glTexCoord3i,
API_glTexCoord3iv,
API_glTexCoord3s,
API_glTexCoord3sv,
API_glTexCoord4d,
API_glTexCoord4dv,
API_glTexCoord4f,
API_glTexCoord4fv,
API_glTexCoord4i,
API_glTexCoord4iv,
API_glTexCoord4s,
API_glTexCoord4sv,
API_glTexCoordPointer,
API_glTexEnvf,
API_glTexEnvfv,
API_glTexEnvi,
API_glTexEnviv,
API_glTexGend,
API_glTexGendv,
API_glTexGenf,
API_glTexGenfv,
API_glTexGeni,
API_glTexGeniv,
API_glTexImage1D,
API_glTexImage2D,
API_glTexImage3D,
API_glTexParameterf,
API_glTexParameterfv,
API_glTexParameteri,
API_glTexParameteriv,
API_glTexSubImage1D,
API_glTexSubImage2D,
API_glTranslated,
API_glTranslatef,
API_glVertex2d,
API_glVertex2dv,
API_glVertex2f,
API_glVertex2fv,
API_glVertex2i,
API_glVertex2iv,
API_glVertex2s,
API_glVertex2sv,
API_glVertex3d,
API_glVertex3dv,
API_glVertex3f,
API_glVertex3fv,
API_glVertex3i,
API_glVertex3iv,
API_glVertex3s,
API_glVertex3sv,
API_glVertex4d,
API_glVertex4dv,
API_glVertex4f,
API_glVertex4fv,
API_glVertex4i,
API_glVertex4iv,
API_glVertex4s,
API_glVertex4sv,
API_glVertexPointer,
API_glViewport,
API_glGetString};



#ifdef __cplusplus
} 
#endif

#endif /* __ogl_h_ */ 
